/* You really don't need to look in here unless you are an experienced programmer and want to get to grips
with the code or want to see how it works, and even if you are an experienced programmer probably best you
don't change any thing in this file, it could cause bugs or problems and I am not responsible for any
problem you cause*/


atom
	var
		elevation = 0
		slide = 0
		fall = 0
		turf/last_turf
		list/entry_dir = list()
		fallen
		tmp/is_falling = 0
		tmp/is_sliding = 0


atom
	Enter(atom/A)
		//checks to make sure the expected lower and upper bounds of elevation aren't exceeded
		if(src.elevation < 0) src.elevation = 0
		if(src.elevation > 100) src.elevation = 100
		if(A.elevation < 0) A.elevation = 0
		if(A.elevation > 100) A.elevation = 100


		//elevation of 0 presents a special case where the atom is always enterable
		if(src.elevation == 0)
			return TRUE
		//elevation of 100 is the highest possible elevation therefore entry will always be denied
		if(src.elevation == 100)
			return FALSE

		//if the entering atom is sliding allow it to enter
		if(A.is_sliding	 == 1)
			return TRUE
		//if the entering atom is falling allow it to enter
		if(A.is_falling	 == 1)
			return TRUE


		//entering atom has a lower elevation than the atom being entered
		if(src.elevation > A.elevation)
			if(src.slide)
				return FALSE
			if(src.fall)
				return FALSE
			else
				return TRUE

		//entering atom has a higher elevation than the atom being entered
		if(src.elevation < A.elevation)
			if(src.slide && (A.dir in src.entry_dir))
				src.Slide(A)
			if(src.fall && (A.dir in src.entry_dir))
				src.Fall(A)
			if(!slide && !fall)
				return TRUE
			return FALSE

		//if there is no elevation interaction required just allow normal walking
		else
			return TRUE


/*these are kinfd of linked to the demo as they are customisable, but they are also needed for the library
to work so don't change them unless you know what you are doing*/
atom
	proc
		Slide(var/atom/slider)	//a slow fall so that the atom falls safely and doesnt get injuted
			var/I = slider.icon_state	//stores the atoms icon state
			slider.icon_state = "sliding"	 //changes the atoms icon state to falling
			slider.is_sliding = 1	//sets the atoms is_sliding variable to 1 to let other stuff know what it's doing
			do
				slider.elevation -= 1
				step(slider, slider.dir, 2)
				sleep(4)
			while(slider.elevation >= src.elevation)	//loops a movemoent in the sliding atoms dir until the atom has
			//an elevation below that of what it is sliding on
			slider.is_sliding = 0	//reset is_sliding to 0
			slider.icon_state = I	//restores the atoms icon state to it's original



		Fall(var/atom/faller)	//faster version of slide and can cause injurey if the fall is big enough
			var/I = faller.icon_state
			faller.icon_state = "falling"
			faller.is_falling = 1
			do
				faller.elevation -= 1
				faller.fallen += 1
				step(faller, faller.dir, 16)
				sleep(1)
			while(faller.elevation >= src.elevation)
			faller.is_falling = 0
			faller.icon_state = I
			// you could add some sort of consequence to falling here, such as taking damage.





